import { calcTempsRestant, calcNbPtsTotalQCM, calcNoteBaremeFed, getRandomNumber } from '../src/calcFunctions';
import db from '../src/helpers/DatabaseHelper';

jest.mock('../src/helpers/DatabaseHelper');

describe('calcTempsRestant', () => {
    it('reste du temps', () => {
        const now = Math.floor(Date.now() / 1000);
        const heureDebut = now - 10;
        expect(calcTempsRestant(heureDebut, 60)).toBeGreaterThan(0);
    });

    it('pas de temps restant', () => {
        const now = Math.floor(Date.now() / 1000);
        const heureDebut = now - 100;
        expect(calcTempsRestant(heureDebut, 60)).toBe(-1);
    });
});

describe('calcNoteBaremeFed', () => {
    it('0 pts obtenus', () => {
        expect(calcNoteBaremeFed(0, 50)).toBe(1);
    });
    it('max pts obtenus', () => {
        expect(calcNoteBaremeFed(50, 50)).toBe(6);
    });
    it('pts obtenus', () => {
        expect(calcNoteBaremeFed(40, 50)).toBe(5);
    });
});

describe('getRandomNumber', () => {
    it('retourne un nombre random entre [min, max]', () => {
        const min = 5, max = 10;
        for (let i = 0; i < 100; i++) {
            const result = getRandomNumber(min, max);
            expect(result).toBeGreaterThanOrEqual(min);
            expect(result).toBeLessThanOrEqual(max);
        }
    });
});