import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Router } from '@angular/router';

@Injectable({
    providedIn: 'root'
})
export class AuthConfigService {
    private readonly baseUrl = 'http:///0.0.0.0:30992';
    // public jwtToken: String = "";
    constructor(private readonly http: HttpClient, private readonly router: Router) {
        
    }

    getAuthorizationUrl(): string {
        const clientId = 'f8b0e14f7eee1a718ad0b3f32c52fe34813d56e9052976f076e039d006e24000'; // Remplacez par votre Application ID GitLab
        const redirectUri = 'http://localhost:4200/'; // Assurez-vous que cela correspond
        return `https://githepia.hesge.ch/oauth/authorize?client_id=${clientId}&redirect_uri=${redirectUri}&response_type=code&scope=api`;
    }

    exchangeCodeForToken(code: string){
        return new Promise((resolve, reject) => 
            {
                fetch(`http://0.0.0.0:30992/auth/jwt`, {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json',
                },
                    body: JSON.stringify({ code }), // Corps de la requête contenant le code d'autorisation
                })
                .then(response => response.json())
                .then(data => {localStorage.setItem('access_token', data["token"]); localStorage.setItem('idUser', data["idUser"]); resolve(data)})
                .then(() => window.location.reload())
                .catch(error => reject(error));
            });
    }

    logout() {
        localStorage.removeItem('access_token');
        this.router.navigate(['/']);
    }

    public redirectNoLogin(): void{
        if(!this.loggedIn){
            this.router.navigate(['/']);
        }
    }
    public redirectLogin(): void{
        if(this.loggedIn){
            this.router.navigate(['/qcmRealise']);
        }
    }

    public get loggedIn(): boolean {
        return localStorage.getItem('access_token') !== null;
    }
}
