import { Question } from "./Question"
import "tslib"

export class QcmData{
    idQcm: number
    nomQcm: string
    #tempsMax: number
    tempsStart: number
    randomQuestion: boolean
    questions : Question[]

    constructor(nomQcm: string, tempsMax: number, randomQuestion: boolean, questions : Question[], tempsStart: number, idQcm?: number) {
        this.idQcm = idQcm ?? 0;
        this.nomQcm = nomQcm
        this.questions = questions
        this.randomQuestion = randomQuestion
        this.#tempsMax = tempsMax
        this.tempsStart = tempsStart
    }

    get tempsMaxRaw(): number {
        return this.#tempsMax
    }

    get tempsMax(): number {
        return this.#tempsMax / 60
    }

    set tempsMax(value: number) {
        this.#tempsMax = value * 60
    }

    public delQuestion(q: Question): void{
        if (this.questions) {
            this.questions = this.questions.filter(choice => choice !== q);
        }
    }

    toJSON() {
        return {
            idQcm: this.idQcm,
            nomQcm: this.nomQcm,
            tempsMax: this.tempsMaxRaw,
            tempsStart: this.tempsStart,
            randomQuestion: this.randomQuestion,
            questions : this.questions,
        };
    }
}